describe ActiveSchema::Index do
  include_setup :*

  before do
    model.schema do |t|
      t.string :name
      t.index :name
    end
  end

  # it 'creates indexes that does not exists' do
  #   expect(connection).
  #     to_receive(:index_exists?).
  #     with(model.table_name, [:name], {})

  #   model.apply_schema
  # end

  # should 'remove then add an index of given columns if it has different options' do
  #   model.apply_schema

  #   expect(connection).
  #     to_receive(:index_exists?).
  #     with(model.table_name, [:name], {}).
  #     and_return(true)

  #   expect(connection).
  #     to_receive(:index_exists?).
  #     with(model.table_name, [:name], {unique: true}).
  #     and_return(false)

  #   expect(connection).
  #     to_receive(:remove_index).
  #     with(model.table_name, column: [:name])

  #   model.schema {|t| t.index(:name, unique: true)}

  #   expect do
  #     # NullDB adapter does not really remove indexes
  #     # so ActiveRecord raises an exception when new index with same name added
  #     model.apply_schema
  #   end.to_raise(ArgumentError, /Index.+already exists/)
  # end

  # should 'ignore existing indexes' do
  #   model.apply_schema

  #   expect(connection).
  #     to_receive(:index_exists?).
  #     with(model.table_name, [:name], {}).
  #     and_return(true)

  #   spy(connection, :remove_index)

  #   model.apply_schema

  #   assert(connection).did_not.received(:remove_index)
  # end

  context 'strict mode' do

    before do
      stub(connection, :indexes).
        with(model.table_name) do
          [Struct.new(:name).new('some_manually_added_index')]
        end
    end

    # should 'keep unspecified indexes on unrestricted mode' do
    #   model.schema(strict: false)

    #   spy(connection, :remove_index)

    #   model.apply_schema

    #   assert(connection).did_not.received(:remove_index)
    # end

    should 'remove unspecified indexes on strict mode' do
      model.schema(strict: true)

      # stub(connection, :remove_index)

      expect(connection).
        to_receive(:remove_index).
        with(model.table_name, 'some_manually_added_index').
        with_caller {|c| puts c*"\n"}

      model.apply_schema
      # @__ms__messages.each {|b| p b.reject {|k,v| k == :object}}
    end
  end

end
