require 'minispec'
require 'active_record'
require 'nulldb'
$:.unshift(File.expand_path('../../lib', __FILE__))
require 'active_schema'

ActiveRecord::Base.extend(ActiveSchema::API)
NullDB.configure {|c| def c.project_root; File.expand_path('../', __FILE__) end}

module ActiveSchema::API
  # monkey-patch to easily apply schema on models
  def apply_schema
    ActiveSchema.apply(table_name)
  end
end

shared_setup :* do
  before do
    ActiveRecord::Base.establish_connection(adapter: :nulldb)
    stub(connection, :change_column) # needed to avoid NotImplemented exception
  end

  after do
    ActiveRecord::Base.remove_connection
  end

  let :model do
    Class.new(ActiveRecord::Base) do
      self.table_name = '_%s_' % self.__id__
    end
  end

  let(:connection) { ActiveRecord::Base.connection }
end

Minispec.pattern = 'spec/index*'
require 'minispec/autorun'
