describe ActiveSchema::Table do
  include_setup :*

  before do
    model.schema
  end

  it 'creates tables that does not exists' do
    expect(connection).
      to_receive(:create_table).
      with {|t,*| t == model.table_name}
    model.apply_schema
  end

  it 'does not try to create tables that already exists' do
    mock(connection, table_exists?: true)
    spy(connection, :create_table)
    model.apply_schema
    assure(connection).did_not.received(:create_table)
  end
end
